/***************************************************
//Web: http://www.buydisplay.com
EastRising Technology Co.,LTD
Examples for ER-OLEDM2004-1
Display is Hardward  I2C
Tested and worked with:
Works with Arduino 1.6.0 IDE  
Test OK : Arduino DUE,Arduino mega2560,Arduino UNO Board 
****************************************************/

/*
  == Hardware connection ==
  OLED   =>    Arduino
  *1,4,5,6,10,11,12,13,16    ->    GND   
  *2. VCC    ->    5V
  *7.DB0    ->    SCL
  *8,9.DB1,DB2    ->    SDA   
  *15. RES    ->    9 
*/

#include <Arduino.h>
#include <Wire.h>
#include "er_oled.h"


void setup() {
  Serial.begin(9600);
  Serial.print("OLED Example\n");
  Wire.begin();  
  
  Serial.print("OLED initialize\n"); 
  er_oled_begin();
  Serial.print("OLED display\n"); 
     

}



void loop() {

uint8_t Display_direction=0; 
  er_oled_clear();
  er_oled_string(5, 0, "EastRising",Display_direction);
  er_oled_string(3, 1, "buydisplay.com",Display_direction);
  er_oled_string(5, 2, "hollow!",Display_direction);
  er_oled_string(5, 3, "world!",Display_direction);  
  delay(3000);

 Display_direction=1;   
  er_oled_clear();
  er_oled_string(3, 0, "Rotate display",Display_direction);
  er_oled_string(3, 1, "buydisplay.com",Display_direction);
  er_oled_string(5, 2, "hollow!",Display_direction);
  er_oled_string(5, 3, "world!",Display_direction);    
  delay(3000);
  
   Display_direction=0;  
  er_oled_clear();
  er_oled_string(0, 0, "0123456789abcdefghij",Display_direction);
  er_oled_string(0, 1, "ABCDEF0123456789abcd",Display_direction); 
  er_oled_string(0, 2, "*www.buydisplay.com*",Display_direction);
  er_oled_string(0, 3, "eastrisingtechnology",Display_direction);  
  delay(2000);  
   Display_direction=1;  
  er_oled_clear();
  er_oled_string(0, 0, "0123456789abcdefghij",Display_direction);
  er_oled_string(0, 1, "ABCDEF0123456789abcd",Display_direction); 
  er_oled_string(0, 2, "*www.buydisplay.com*",Display_direction);
  er_oled_string(0, 3, "eastrisingtechnology",Display_direction);  
  delay(2000);   
 
 
   Display_direction=0;  
   er_oled_clear();  
  er_oled_string(2, 0,"2019",Display_direction);  
  er_oled_char(6, 0,0x04,Display_direction);
  er_oled_string(7, 0,"08",Display_direction);
  er_oled_char(9, 0,0x05,Display_direction);
  er_oled_string(10, 0,"28",Display_direction);
  er_oled_char(12, 0,0x06,Display_direction); 
  er_oled_string(2, 1, "12:34:56",Display_direction);   
  er_oled_string(2, 2, "hollow!",Display_direction);
  er_oled_string(2, 3, "world!",Display_direction);    
  delay(2000);  
  
 Display_direction=1;     
   er_oled_clear();  
  er_oled_string(2, 0,"2019",Display_direction);  
  er_oled_char(6, 0,0x04,Display_direction);
  er_oled_string(7, 0,"08",Display_direction);
  er_oled_char(9, 0,0x05,Display_direction);
  er_oled_string(10, 0,"28",Display_direction);
  er_oled_char(12, 0,0x06,Display_direction); 
  er_oled_string(2, 1, "12:34:56",Display_direction);   
  er_oled_string(2, 2, "hollow!",Display_direction);
  er_oled_string(2, 3, "world!",Display_direction);    
  delay(2000);   
 Display_direction=0;    
  
 Write_DDRAM(0x1f);	
  delay(2000); 			 
  Write_DDRAM(0);	
  delay(2000); 	
  Write_DDRAM(1);
  delay(2000); 		
  Write_DDRAM(2);
  delay(2000); 	
  Write_DDRAM(3);
  delay(2000); 	
  Write_DDRAM(4);
  delay(2000); 	
  Write_DDRAM(5);
  delay(2000); 	
  Write_DDRAM(6);
  delay(2000); 	 
  Write_DDRAM(7);
  delay(2000); 		  
  

}

